/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_voip_sip_addrbook(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	sValue[MAX_DATA_LEN];
	
	
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}
	memset(sValue, 0x00, MAX_DATA_LEN);

	if (!gstrcmp(name, T("updateData")))
	{
#ifdef ATA
			ifx_httpdWrite(wp,T("if (document.tF0.selport.selectedIndex == 0) \n"));      
			ifx_httpdWrite(wp,T("{\n"));
			strcpy(argv[0], "port1");
			ifx_get_voip_addrbook(eid, wp, argc, argv); //("port1");
			ifx_httpdWrite(wp,T("}\n"));
			ifx_httpdWrite(wp,T("else\n"));
			ifx_httpdWrite(wp,T("{\n"));
			strcpy(argv[0], "port2");			
			ifx_get_voip_addrbook(eid, wp, argc, argv); //("port2");			
			ifx_httpdWrite(wp,T("}\n"));
#endif //#ifdef ATA
#ifdef IIP
			strcpy(argv[0], "port1");
			ifx_get_voip_addrbook(eid, wp, argc, argv); //("port1");
#endif //#ifdef IIP
	}else
	if(!gstrcmp(name, T("ADial")))
	{
#ifdef ATA
		     ifx_httpdWrite(wp,"document.tF0.dial.value= ADial[num];\n");
#endif //#ifdef ATA
	}else
	if(!gstrcmp(name, T("DialCode")))
	{
#ifdef ATA
	       	ifx_httpdWrite(wp,"<tr class=\"celltext\" bgcolor=\"#ffffff\">");
	       	ifx_httpdWrite(wp,"<td width=\"20%\">Dial Code:</td>");
	       	ifx_httpdWrite(wp,"<td width=\"60%\">");
	       	ifx_httpdWrite(wp,"<input type=\"INT\" name=\"dial\" maxlength=16 size=\"16\" value=\"\">&nbsp;");						
	       	ifx_httpdWrite(wp,"</td>");			
	       	ifx_httpdWrite(wp,"<td width=\"20%\"></td>");			
	       	ifx_httpdWrite(wp," </tr>");      	
#endif //#ifdef ATA
	}else
	if(!gstrcmp(name, T("PortSelection")))
	{
#ifdef ATA
			 ifx_httpdWrite(wp,"<tr>");
			 ifx_httpdWrite(wp,"<td width=\"20%\" ><font class=\"subtitle\">Port Selection:</font></td>");
	 		 ifx_httpdWrite(wp,"<td width=\"80%\">");
			 ifx_httpdWrite(wp,"<select name=\"selport\" size=\"1\" onChange=\"updateData();\">");
			 ifx_httpdWrite(wp,"<option value=0 selected>Port 1</option>");		 
			 ifx_httpdWrite(wp,"<option value=1>Port 2</option>");
			 ifx_httpdWrite(wp,"</select>");
			 ifx_httpdWrite(wp,"</td>");
			 ifx_httpdWrite(wp,"</tr>");		 	 	
#endif //#ifdef ATA
	}else
   if(!gstrcmp(name,T("VADTAG")))
	{
#ifdef IIP
	            ifx_httpdWrite(wp,"<tr class=\"celltext\" bgcolor=\"#ffffff\">");
       	     ifx_httpdWrite(wp,"<td width=\"20%\" >VAD TAG:</td>");
	            ifx_httpdWrite(wp,"<td width=\"40%\" >");
       	     ifx_httpdWrite(wp,"<select name=\"vad\" >");
	            ifx_httpdWrite(wp,"<option value=0 selected>TAG_OFF</option>");
	            ifx_httpdWrite(wp,"<option value=1>TAG_ON</option>");
	            ifx_httpdWrite(wp,"</select>");
       	     ifx_httpdWrite(wp,"</td>");
	            ifx_httpdWrite(wp,"<td width=\"20%\"></td>");
	            ifx_httpdWrite(wp,"</tr>");	
#endif //#ifdef IIP
	}
   else
   if(!gstrcmp(name,T("DisVad")))
	{
#ifdef IIP
         		 ifx_httpdWrite(wp,"document.tF0.vad.selectedIndex = AVad[num];");
			 ifx_httpdWrite(wp,"document.tF0.vad.disabled = true;");
#endif //#ifdef IIP
	}		 
	return 0;
}

/*****************************************************************************
 *  Function Name   : ifx_get_voip_addrbook
 *  Description     : This function is called voip_sip_addrbook.asp page
 *  Input Values    : 
 *  Output Values   :
 *
 *  Return Value    : 0  - Success
 *                    -1 - Failure
 *  Notes           :
 ****************************************************************************/
int ifx_get_voip_addrbook(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	sValue[MAX_DATA_LEN];
	x_IFX_CM_Msg xCmMsg;
	int 		nIndex = 0;

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}

 	memset(sValue, 0x00, MAX_DATA_LEN);
   	if (!gstrcmp(name, T("port1")))
   	{
	   	// Get Data from CM
		memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
	   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
		xCmMsg.ucInfoType = IFX_CM_APP_ADDR_ENTRY;
		xCmMsg.ucChannel = 0;  /* For port 1*/
		    		
	    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
		{
			ifx_httpdError(wp, 200, T("Fail to receive ADDR_ENTRY data from CM\n"));
			return -1;
		}

		//trace(8, "AddrBook-P1 Channel ==>%d\n", xCmMsg.ucChannel);
		//trace(8, "AddrBook-P1 Entries ==>%d\n", NoOfPbEntries);
		ifx_httpdWrite(wp, "document.tF0.addrEntries.length = %d;", NoOfPbEntries);
      if (NoOfPbEntries == 0)
      {
         ifx_httpdWrite(wp, "loc[0]=0;\n");
         ifx_httpdWrite(wp, "field[0]=0;\n");
         ifx_httpdWrite(wp, "AAddrType[0]=0;\n");
         ifx_httpdWrite(wp, "document.tF0.addrEntries[0] = new Option(\" \");\n");
         ifx_httpdWrite(wp, "document.tF0.addrEntries[0].value = 0;");
         ifx_httpdWrite(wp, "AUName[0]=\"\";\n");
         ifx_httpdWrite(wp, "ADName[0]=\"\";\n");
         ifx_httpdWrite(wp, "AAddr[0]=\"\";\n");
         ifx_httpdWrite(wp, "APort[0]=\"\";\n");
         ifx_httpdWrite(wp, "Aaddrproto[0]=\"\";\n");

#ifdef ATA
         	ifx_httpdWrite(wp, "ADial[0]=\"\";\n");
#endif //#ifdef ATA
#ifdef IIP
          	ifx_httpdWrite(wp, "AVad[0]=0;\n");
#endif //#ifdef IIP
      }

		for (nIndex=0; nIndex<NoOfPbEntries; nIndex++)
		{
			x_IFX_CM_AppAddressBookEntry entry;
			memset(&entry, 0, sizeof(x_IFX_CM_AppAddressBookEntry));
			entry = xPBEntry[nIndex];

			/***********
			loc[0]=0
			field[0]="0"
			AAddrType[0]=0;
			***********/
			ifx_httpdWrite(wp, "loc[%d]=%d;\n", nIndex, nIndex);
			ifx_httpdWrite(wp, "field[%d]=%d;\n", nIndex, nIndex);
			ifx_httpdWrite(wp, "AAddrType[%d]=%d;\n", nIndex, entry.eAddrType);			

			switch (entry.eAddrType)
			{
			case IFX_CM_SIP_IP_ADDR:
				/********************
				document.tF0.addrEntries[0] = new Option("1 -- DisplayUserName/Username");
				document.tF0.addrEntries[0].value=0;
				AUName[0]="User"
				ADName[0]="Roger"	
				AAddr[0]="192.168.1.101"
				APort[0]=1024
				ADial[0]=2
				*********************/

				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d] = new Option(\"%d -- %s/%s\");\n", nIndex, nIndex+1, entry.ux_IFX_CM_AppAddr.x_IpAddr.aucUsrName, entry.ux_IFX_CM_AppAddr.x_IpAddr.aucDispName);
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d].value = %d;", nIndex, nIndex);
				ifx_httpdWrite(wp, "AUName[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_IpAddr.aucUsrName);
				ifx_httpdWrite(wp, "ADName[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_IpAddr.aucDispName);
				ifx_httpdWrite(wp, "AAddr[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_IpAddr.aucIPAddr);
				ifx_httpdWrite(wp, "APort[%d]=\"%d\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_IpAddr.unDestPort);
#ifdef ATA
					ifx_httpdWrite(wp, "ADial[%d]=\"%s\";\n", nIndex, entry.acDialCode);				
#endif //#ifdef ATA

		      if ( entry.ucAddrProto == 0)
				ifx_httpdWrite(wp,"Aaddrproto[%d]=0;\n", nIndex);
				else if(entry.ucAddrProto == 1)
				  ifx_httpdWrite(wp,"Aaddrproto[%d]=1;\n", nIndex);
				else
				  ifx_httpdWrite(wp,"Aaddrproto[%d]=2;\n", nIndex);

#ifdef IIP
				if (entry.cVectorIndex == 0)
				    ifx_httpdWrite(wp, "AVad[%d]=0;\n", nIndex);				
			   	else
				    ifx_httpdWrite(wp, "AVad[%d]=1;\n", nIndex);				
#endif		
				break;
				
			case IFX_CM_SIP_TEL_NUM:
				/********************
				document.tF0.addrEntries[0] = new Option("1 -- DisplayUserName/Username");
				document.tF0.addrEntries[0].value = 0;				
				AUName[0]="Username";
				ADName[0]="";	
				AAddr[0]="192.168.1.102";
				APort[0]="";
				ADial[0]=2;
				*********************/
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d] = new Option(\"%d -- %s\");\n", nIndex, nIndex+1, entry.ux_IFX_CM_AppAddr.x_TelUri.aucDispName);
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d].value = %d;", nIndex, nIndex);
				ifx_httpdWrite(wp, "ADName[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_TelUri.aucDispName);
				ifx_httpdWrite(wp, "AUName[%d]=\"\";\n", nIndex);
				ifx_httpdWrite(wp, "AAddr[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_TelUri.aucTelNumber);
				ifx_httpdWrite(wp, "APort[%d]=\"\";\n", nIndex);

#ifdef ATA
            				ifx_httpdWrite(wp, "ADial[%d]=\"%s\";\n", nIndex, entry.acDialCode);
#endif //#ifdef ATA

		            if ( entry.ucAddrProto == 0)
            				ifx_httpdWrite(wp,"Aaddrproto[%d]=0;\n", nIndex);
            		     else if(entry.ucAddrProto == 1)
              			ifx_httpdWrite(wp,"Aaddrproto[%d]=1;\n", nIndex);
            		     else
              			ifx_httpdWrite(wp,"Aaddrproto[%d]=2;\n", nIndex);

			#ifdef IIP
					if (entry.cVectorIndex == 0)
				    		ifx_httpdWrite(wp, "AVad[%d]=0;\n", nIndex);				
			   		else
				    		ifx_httpdWrite(wp, "AVad[%d]=1;\n", nIndex);				
			#endif				
				break;				

			case IFX_CM_SIP_URL:
				/********************
				document.tF0.addrEntries[0] = new Option("1 -- DisplayUserName/Username");
				document.tF0.addrEntries[0].value = 0;				
				AUName[0]="User"
				ADName[0]="Roger"	
				AAddr[0]="192.168.1.101"
				APort[0]=1024
				ADial[0]=2
				*********************/
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d] = new Option(\"%d -- %s/%s\");\n", nIndex, nIndex+1, entry.ux_IFX_CM_AppAddr.x_SipUri.aucUsrName, entry.ux_IFX_CM_AppAddr.x_SipUri.aucDispName);
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d].value = %d;", nIndex, nIndex);				
				ifx_httpdWrite(wp, "AUName[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_SipUri.aucUsrName);
				ifx_httpdWrite(wp, "ADName[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_SipUri.aucDispName);
				ifx_httpdWrite(wp, "AAddr[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_SipUri.aucIPAddr);
				ifx_httpdWrite(wp, "APort[%d]=\"%d\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_SipUri.unDestPort);

#ifdef ATA
            				ifx_httpdWrite(wp, "ADial[%d]=\"%s\";\n", nIndex, entry.acDialCode);
#endif //#ifdef ATA
            			if ( entry.ucAddrProto == 0)
            				ifx_httpdWrite(wp,"Aaddrproto[%d]=0;\n", nIndex);
            			else if(entry.ucAddrProto == 1)
              			ifx_httpdWrite(wp,"Aaddrproto[%d]=1;\n", nIndex);
            			else
              			ifx_httpdWrite(wp,"Aaddrproto[%d]=2;\n", nIndex);

#ifdef IIP
					if (entry.cVectorIndex == 0)
				    		ifx_httpdWrite(wp, "AVad[%d]=0;\n", nIndex);				
			   		else
				    		ifx_httpdWrite(wp, "AVad[%d]=1;\n", nIndex);				
#endif				
				break;
				
			case IFX_CM_SIP_EXTN:
			default:
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d] = new Option(\"%d -- \");\n", nIndex, nIndex+1);
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d].value = %d;", nIndex, nIndex);				
				ifx_httpdWrite(wp, "AUName[%d]=\"\";\n", nIndex);
				ifx_httpdWrite(wp, "ADName[%d]=\"\";\n", nIndex);
				ifx_httpdWrite(wp, "AAddr[%d]=\"\";\n", nIndex);
				ifx_httpdWrite(wp, "APort[%d]=\"\";\n", nIndex);
				ifx_httpdWrite(wp, "ADial[%d]=\"\";\n", nIndex);
			}
		}			
   	}
   	else if (!gstrcmp(name, T("port2")))
   	{
	   	// Get Data from CM
		memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
	   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
		xCmMsg.ucInfoType = IFX_CM_APP_ADDR_ENTRY;
		xCmMsg.ucChannel = 1;  /* For port 1*/
		    		
	    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
		{
			ifx_httpdError(wp, 200, T("Fail to receive ADDR_ENTRY data from CM\n"));
			return -1;
		}
		//trace(8, "AddrBook-P2 Channel ==>%d\n", xCmMsg.ucChannel);
		//trace(8, "AddrBook-P2 Entries ==>%d\n", NoOfPbEntries);
		
		ifx_httpdWrite(wp, "document.tF0.addrEntries.length = %d;", NoOfPbEntries);
      if (NoOfPbEntries == 0)
      {
         ifx_httpdWrite(wp, "loc[0]=0;\n");
         ifx_httpdWrite(wp, "field[0]=0;\n");
         ifx_httpdWrite(wp, "AAddrType[0]=0;\n");
         ifx_httpdWrite(wp, "document.tF0.addrEntries[0] = new Option(\" \");\n");
         ifx_httpdWrite(wp, "document.tF0.addrEntries[0].value = 0;");
         ifx_httpdWrite(wp, "AUName[0]=\"\";\n");
         ifx_httpdWrite(wp, "ADName[0]=\"\";\n");
         ifx_httpdWrite(wp, "AAddr[0]=\"\";\n");
         ifx_httpdWrite(wp, "APort[0]=\"\";\n");

#ifdef ATA
         	ifx_httpdWrite(wp, "ADial[0]=\"\";\n");
#endif //#ifdef ATA
         ifx_httpdWrite(wp, "Aaddrproto[0]=\"\";\n");
#ifdef IIP
         	ifx_httpdWrite(wp, "AVad[0]=0;\n");
#endif
      }
		for (nIndex=0; nIndex<NoOfPbEntries; nIndex++)
		{
			x_IFX_CM_AppAddressBookEntry entry;
			entry = xPBEntry[nIndex];
			/***********
			loc[0]=0
			field[0]="0"
			AAddrType[0]=0;			
			***********/
			ifx_httpdWrite(wp, "loc[%d]=%d;\n", nIndex, nIndex);
			ifx_httpdWrite(wp, "field[%d]=%d;\n", nIndex, nIndex);
			ifx_httpdWrite(wp, "AAddrType[%d]=%d;\n", nIndex, entry.eAddrType);
			switch (entry.eAddrType)
			{
			case IFX_CM_SIP_IP_ADDR:
				/********************
				document.tF0.addrEntries[0] = new Option("1 -- DisplayUserName/Username");
				document.tF0.addrEntries[0].value = 0;				
				AUName[0]="User"
				ADName[0]="Roger"	
				AAddr[0]="192.168.1.101"
				APort[0]=1024
				ADial[0]=2
				*********************/
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d] = new Option(\"%d -- %s/%s\");\n", nIndex, nIndex+1, entry.ux_IFX_CM_AppAddr.x_IpAddr.aucUsrName, entry.ux_IFX_CM_AppAddr.x_IpAddr.aucDispName);				
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d].value = %d;", nIndex, nIndex);				
				ifx_httpdWrite(wp, "AUName[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_IpAddr.aucUsrName);
				ifx_httpdWrite(wp, "ADName[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_IpAddr.aucDispName);
				ifx_httpdWrite(wp, "AAddr[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_IpAddr.aucIPAddr);
				ifx_httpdWrite(wp, "APort[%d]=\"%d\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_IpAddr.unDestPort);

#ifdef ATA
			            ifx_httpdWrite(wp, "ADial[%d]=\"%s\";\n", nIndex, entry.acDialCode);
#endif //#ifdef ATA
                        	if ( entry.ucAddrProto == 0)
				       ifx_httpdWrite(wp,"Aaddrproto[%d]=0;\n", nIndex);
		             else if(entry.ucAddrProto == 1)
  			              ifx_httpdWrite(wp,"Aaddrproto[%d]=1;\n", nIndex);
            		      else
              			ifx_httpdWrite(wp,"Aaddrproto[%d]=2;\n", nIndex);

#ifdef IIP
					if (entry.cVectorIndex == 0)
				    		ifx_httpdWrite(wp, "AVad[%d]=0;\n", nIndex);				
			   		else
				    		ifx_httpdWrite(wp, "AVad[%d]=1;\n", nIndex);				
#endif				
				break;
				
			case IFX_CM_SIP_TEL_NUM:
				/********************
				document.tF0.addrEntries[0] = new Option("1 -- DisplayUserName/Username");
				document.tF0.addrEntries[0].value = 0;
				AUName[0]="Username";
				ADName[0]="";	
				AAddr[0]="192.168.1.102";
				APort[0]="";
				ADial[0]=2;
				*********************/
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d] = new Option(\"%d -- %s\");\n", nIndex, nIndex+1, entry.ux_IFX_CM_AppAddr.x_TelUri.aucDispName);
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d].value = %d;", nIndex, nIndex);
				ifx_httpdWrite(wp, "ADName[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_TelUri.aucDispName);
				ifx_httpdWrite(wp, "AUName[%d]=\"\";\n", nIndex);
				ifx_httpdWrite(wp, "AAddr[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_TelUri.aucTelNumber);
				ifx_httpdWrite(wp, "APort[%d]=\"\";\n", nIndex);

#ifdef ATA
				 	ifx_httpdWrite(wp, "ADial[%d]=\"%s\";\n", nIndex, entry.acDialCode);
#endif //#ifdef ATA
                        	if ( entry.ucAddrProto == 0)
			       	ifx_httpdWrite(wp,"Aaddrproto[%d]=0;\n", nIndex);
            			else if(entry.ucAddrProto == 1)
              			ifx_httpdWrite(wp,"Aaddrproto[%d]=1;\n", nIndex);
            			else
              			ifx_httpdWrite(wp,"Aaddrproto[%d]=2;\n", nIndex);
				
#ifdef IIP
					if (entry.cVectorIndex == 0)
				    		ifx_httpdWrite(wp, "AVad[%d]=0;\n", nIndex);				
			   		else
				    		ifx_httpdWrite(wp, "AVad[%d]=1;\n", nIndex);				
#endif				
				break;				

			case IFX_CM_SIP_URL:
				/********************
				document.tF0.addrEntries[0] = new Option("1 -- DisplayUserName/Username");
				document.tF0.addrEntries[0].value = 0;				
				AUName[0]="User"
				ADName[0]="Roger"	
				AAddr[0]="192.168.1.101"
				APort[0]=1024
				ADial[0]=2
				*********************/
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d] = new Option(\"%d -- %s/%s\");\n", nIndex, nIndex+1, entry.ux_IFX_CM_AppAddr.x_SipUri.aucUsrName, entry.ux_IFX_CM_AppAddr.x_SipUri.aucDispName);
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d].value = %d;", nIndex, nIndex);
				ifx_httpdWrite(wp, "AUName[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_SipUri.aucUsrName);
				ifx_httpdWrite(wp, "ADName[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_SipUri.aucDispName);
				ifx_httpdWrite(wp, "AAddr[%d]=\"%s\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_SipUri.aucIPAddr);
				ifx_httpdWrite(wp, "APort[%d]=\"%d\";\n", nIndex, entry.ux_IFX_CM_AppAddr.x_SipUri.unDestPort);				

#ifdef ATA
	            			ifx_httpdWrite(wp, "ADial[%d]=\"%s\";\n", nIndex, entry.acDialCode);
#endif //#ifdef ATA
                        	if ( entry.ucAddrProto == 0)
            				ifx_httpdWrite(wp,"Aaddrproto[%d]=0;\n", nIndex);
            			else if(entry.ucAddrProto == 1)
              			ifx_httpdWrite(wp,"Aaddrproto[%d]=1;\n", nIndex);
            			else
              			ifx_httpdWrite(wp,"Aaddrproto[%d]=2;\n", nIndex);

#ifdef IIP
					if (entry.cVectorIndex == 0)
				    		ifx_httpdWrite(wp, "AVad[%d]=0;\n", nIndex);				
			   		else
				    		ifx_httpdWrite(wp, "AVad[%d]=1;\n", nIndex);				
#endif		
				break;
				
			case IFX_CM_SIP_EXTN:
			default:
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d] = new Option(\"%d -- \");\n", nIndex, nIndex+1);
				ifx_httpdWrite(wp, "document.tF0.addrEntries[%d].value = %d;", nIndex, nIndex);
				ifx_httpdWrite(wp, "AUName[%d]=\"\";\n", nIndex);
				ifx_httpdWrite(wp, "ADName[%d]=\"\";\n", nIndex);
				ifx_httpdWrite(wp, "AAddr[%d]=\"\";\n", nIndex);
				ifx_httpdWrite(wp, "APort[%d]=\"\";\n", nIndex);
				ifx_httpdWrite(wp, "ADial[%d]=\"\";\n", nIndex);
			}
		}
	}   
	
	return 0;	
}


void ifx_set_voip_sip_addrbook(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*paddflag  = ifx_httpdGetVar(wp, T("addflag"), T(""));
	char_t	*pmodflag  = ifx_httpdGetVar(wp, T("modflag"), T(""));
	char_t	*pdelflag   = ifx_httpdGetVar(wp, T("delflag"), T(""));	
	char_t	*pselport   = ifx_httpdGetVar(wp, T("selport"), T(""));
	char_t	*paddrEntries   = ifx_httpdGetVar(wp, T("addrEntries"), T(""));	
#ifdef ATA        
	char_t	*pdial      = ifx_httpdGetVar(wp, T("dial"), T(""));	
#endif        
	char_t	*paddrtype = ifx_httpdGetVar(wp, T("addrtype"), T(""));
	char_t	*puname   = ifx_httpdGetVar(wp, T("uname"), T(""));	
	char_t	*pdname   = ifx_httpdGetVar(wp, T("dname"), T(""));
	char_t	*paddr     = ifx_httpdGetVar(wp, T("addr"), T(""));
	char_t	*pport     = ifx_httpdGetVar(wp, T("port"), T(""));	
	char_t	*pproto     = ifx_httpdGetVar(wp, T("addrproto"), T(""));	
	
	x_IFX_CM_Msg xCmMsg;
	x_IFX_CM_AppAddressBookEntry entry;

	a_assert(wp);
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
	if (pselport == 0 || paddrEntries == 0 || puname== 0 || paddrtype == 0 || pport == 0 || pproto == 0)
	{
		ifx_httpdError(wp, 200, "Error in Phone Book Parameter");
		return;
	}

	// Get Data from CM
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_APP_ADDR_ENTRY;
	xCmMsg.ucChannel = atoi(pselport);
		    		
	if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
		ifx_httpdError(wp, 200, T("Fail to receive ADDR_ENTRY data from CM\n"));
		return ;
	}

	if (gatoi(paddflag) == 1) /* press Add button */
	{
	   if (NoOfPbEntries == 50)
	   {
		   ifx_httpdError(wp, 200, "Max Phone Book Entries exceeded, Cannot add more!!!");
		   return;
	   }

		memset(&entry, 0, sizeof(x_IFX_CM_AppAddressBookEntry));		
	   	xCmMsg.ucMsgType = IFX_CM_SET_REQ;
		xCmMsg.ucInfoType = IFX_CM_APP_ADD_ADDR_ENTRY;
		xCmMsg.ucChannel = gatoi(pselport);  /* For port 1*/

		entry.eAddrType = gatoi(paddrtype);
		entry.ucAddrProto = gatoi(pproto);
		switch (gatoi(paddrtype))
		{
		case IFX_CM_SIP_IP_ADDR:
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_IpAddr.aucDispName, pdname);
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_IpAddr.aucUsrName, puname);
                        if ( IFX_ValidateIpAddress(paddr) < 0)
                        {
                            ifx_httpdError(wp, 200, T("Invalid IP address!!!"));
                            return;
                        }
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_IpAddr.aucIPAddr, paddr);
			entry.ux_IFX_CM_AppAddr.x_IpAddr.unDestPort = gatoi(pport);

#ifdef ATA
			gstrcpy(entry.acDialCode,pdial);
#endif
			break;
		case IFX_CM_SIP_TEL_NUM:
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_TelUri.aucDispName, pdname);
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_TelUri.aucTelNumber, paddr);

#ifdef ATA
			gstrcpy(entry.acDialCode,pdial);
#endif
			break;
		case IFX_CM_SIP_URL:
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_SipUri.aucDispName, pdname);
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_SipUri.aucUsrName, puname);
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_SipUri.aucIPAddr, paddr);
			entry.ux_IFX_CM_AppAddr.x_SipUri.unDestPort = gatoi(pport);
#ifdef ATA
			gstrcpy(entry.acDialCode,pdial);
#endif
			break;
		default:
			break;
		}

//		xCmMsg.uxData.xAddrBookCfg.ucNoOfEntries = gatoi(paddrEntries);
//		xCmMsg.uxData.xAddrBookCfg.xAddrBookEntry[gatoi(paddrEntries)] = entry;
		xCmMsg.uxData.xModAddrBookCfg.xNewAddrEntry = entry;
	    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
	    {
			ifx_httpdError(wp, 200, T("Fail to send ADD_ADDR_ENTRY data to CM"));
			return;     	
	    }
		 if (xCmMsg.ucMsgType == IFX_CM_SET_ERR_RSP)
		 {
			ifx_httpdError(wp, 200, T("Duplicate Address book Entry"));
			return;     	
		 }
	}

	if (gatoi(pmodflag) ==1) /* press Modify button*/
	{
		x_IFX_CM_AppAddressBookEntry newEntry, oldEntry;
		if (NoOfPbEntries == 0)
      {
         ifx_httpdError(wp, 200, "NO Phone Book Entries , Cannot modify !!!");
         return;
      }
		memset(&newEntry, 0, sizeof(x_IFX_CM_AppAddressBookEntry));	
		memset(&oldEntry, 0, sizeof(x_IFX_CM_AppAddressBookEntry));
					
		/* Get old entry first */		
		memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
	   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
		xCmMsg.ucInfoType = IFX_CM_APP_ADDR_ENTRY;
		xCmMsg.ucChannel = gatoi(pselport);	// Current port
		    		
	    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
		{
			ifx_httpdError(wp, 200, T("Fail to receive data from CM\n"));
			return;
		}
		oldEntry = xPBEntry[gatoi(paddrEntries)];
		/* Process new entry here */
		memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
	   	xCmMsg.ucMsgType = IFX_CM_SET_REQ;
		xCmMsg.ucInfoType = IFX_CM_APP_MODIFY_ADDR_ENTRY;
		xCmMsg.ucChannel = gatoi(pselport);

		newEntry.eAddrType = gatoi(paddrtype);
		newEntry.ucAddrProto = gatoi(pproto);
#ifdef IIP		
		newEntry.cVectorIndex = oldEntry.cVectorIndex;
#endif /*IIP*/			
		switch (gatoi(paddrtype))
		{
		case IFX_CM_SIP_IP_ADDR:
			gstrcpy(newEntry.ux_IFX_CM_AppAddr.x_IpAddr.aucDispName, pdname);
			gstrcpy(newEntry.ux_IFX_CM_AppAddr.x_IpAddr.aucUsrName, puname);
                        if ( IFX_ValidateIpAddress(paddr) < 0)
                        {
                           ifx_httpdError(wp, 200, T("Invalid IP address!!!"));
                           return;
                        }
			gstrcpy(newEntry.ux_IFX_CM_AppAddr.x_IpAddr.aucIPAddr, paddr);
			newEntry.ux_IFX_CM_AppAddr.x_IpAddr.unDestPort = gatoi(pport);

#ifdef ATA
			gstrcpy(newEntry.acDialCode,pdial);
#endif
			break;
		case IFX_CM_SIP_TEL_NUM:
			gstrcpy(newEntry.ux_IFX_CM_AppAddr.x_TelUri.aucDispName, pdname);
			gstrcpy(newEntry.ux_IFX_CM_AppAddr.x_TelUri.aucTelNumber, paddr);

#ifdef ATA
			gstrcpy(newEntry.acDialCode,pdial);
#endif
			break;
		case IFX_CM_SIP_URL:
			gstrcpy(newEntry.ux_IFX_CM_AppAddr.x_SipUri.aucDispName, pdname);
			gstrcpy(newEntry.ux_IFX_CM_AppAddr.x_SipUri.aucUsrName, puname);
			gstrcpy(newEntry.ux_IFX_CM_AppAddr.x_SipUri.aucIPAddr, paddr);
			newEntry.ux_IFX_CM_AppAddr.x_SipUri.unDestPort = gatoi(pport);

#ifdef ATA
			gstrcpy(newEntry.acDialCode,pdial);
#endif
			break;
		default:
			break;
		}

		xCmMsg.uxData.xModAddrBookCfg.xOldAddrEntry = oldEntry;
		xCmMsg.uxData.xModAddrBookCfg.xNewAddrEntry = newEntry;
	    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
	    {
			ifx_httpdError(wp, 200, T("Fail to send MODIFY_ADDR_ENTRY data to CM"));
			return;     	
	    }
		 if (xCmMsg.ucMsgType == IFX_CM_SET_ERR_RSP)
		 {
			ifx_httpdError(wp, 200, T("Duplicate Address book Entry"));
			return;     	
		 }
	}
		
	if (gatoi(pdelflag) ==1) /* press Delete button*/
	{
		x_IFX_CM_AppAddressBookEntry entry;
		if (NoOfPbEntries == 0)
      {
         ifx_httpdError(wp, 200, "NO Phone Book Entries , Cannot del !!!");
         return;
      }
		memset(&entry, 0, sizeof(x_IFX_CM_AppAddressBookEntry));		
	   	xCmMsg.ucMsgType = IFX_CM_SET_REQ;
		xCmMsg.ucInfoType = IFX_CM_APP_DELETE_ADDR_ENTRY;
		xCmMsg.ucChannel = gatoi(pselport);

		entry.eAddrType = gatoi(paddrtype);
		entry.ucAddrProto = gatoi(pproto);
		switch (gatoi(paddrtype))
		{
		case IFX_CM_SIP_IP_ADDR:
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_IpAddr.aucDispName, pdname);
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_IpAddr.aucUsrName, puname);
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_IpAddr.aucIPAddr, paddr);
			entry.ux_IFX_CM_AppAddr.x_IpAddr.unDestPort = gatoi(pport);

#ifdef ATA
			gstrcpy(entry.acDialCode,pdial);
#endif
			break;
		case IFX_CM_SIP_TEL_NUM:
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_TelUri.aucDispName, pdname);
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_TelUri.aucTelNumber, paddr);

#ifdef ATA
			gstrcpy(entry.acDialCode,pdial);
#endif
			break;
		case IFX_CM_SIP_URL:
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_SipUri.aucDispName, pdname);
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_SipUri.aucUsrName, puname);
			gstrcpy(entry.ux_IFX_CM_AppAddr.x_SipUri.aucIPAddr, paddr);
			entry.ux_IFX_CM_AppAddr.x_SipUri.unDestPort = gatoi(pport);

#ifdef ATA
			gstrcpy(entry.acDialCode,pdial);
#endif
			break;
		default:
			break;
		}

#ifdef IIP
      	entry=xPBEntry[gatoi(paddrEntries)];
#endif
//		xCmMsg.uxData.xAddrBookCfg.ucNoOfEntries = gatoi(paddrEntries);
		xCmMsg.uxData.xModAddrBookCfg.xOldAddrEntry = entry;
	    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
	    {
			ifx_httpdError(wp, 200, T("Fail to send DELETE_ADDR_ENTRY data to CM"));
			return;     	
	    }
	}
	
	ifx_httpdNextPage(wp);
}

