#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<stdio.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
//#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>
#define MAX_FILELINE_LEN 80
#define MAX_FILENAME_LEN 80
#define BUF_SIZE_50K 5000
#define MAX_TAG_LEN 80
#define FILE_RC_CONF "/nv/rc.conf"
#define TAG_WLAN_SETTINGS "wlan_settings"
#define DEFAULT_SSID "Sinus TC 300"
#define APC_SURVEY   "/nv/a"

	
#include <sys/ioctl.h>
#include "ioctl.h"
#include <fcntl.h>

int  RWReg(int tt,int led_c)
{
  int fd;
  int value=0;
  int rwmode=0;
  PREGRW uREGRW;
  if (led_c) {
  fd = open("/dev/adm8668", O_RDWR, 0);

  uREGRW = (PREGRW)malloc(sizeof(REGRW));
  	
  uREGRW->addr = 0x1180005c;
  uREGRW->mode = 0;
   {
     if( ioctl(fd, ADM_IOCTL_REGRW, uREGRW) )
     {
       printf("ioctl error\n");
       return;
     }
	  
     read(fd, uREGRW, sizeof(uREGRW));
     value = uREGRW->value & tt; //0x4 for pair,0x2 for reset to default
     
  }

  close(fd);
  free(uREGRW);
  if (value==0) return 1;
  return 0;
	}
	else {
  fd = open("/dev/adm8668", O_RDWR, 0);

  uREGRW = (PREGRW)malloc(sizeof(REGRW));
  	
  uREGRW->addr = 0x11400020;
  uREGRW->mode = 0;
   {
     if( ioctl(fd, ADM_IOCTL_REGRW, uREGRW) )
     {
       printf("ioctl error\n");
       return;
     }
	  
     read(fd, uREGRW, sizeof(uREGRW));
     if (tt) 
     value = uREGRW->value | 0x00000040; //SP Led off
     else
     value = uREGRW->value & 0xffffffbf; //SP Led on
     uREGRW->mode = 1;
     uREGRW->value=value;
     if( ioctl(fd, ADM_IOCTL_REGRW, uREGRW) )
     {
       printf("ioctl error\n");
       return;
     }
     
     write(fd, uREGRW, sizeof(uREGRW));
     
  }

  close(fd);
  free(uREGRW);
		
	}
}


//***************************** Common API ********************************
////////////////////////////////////////////////////////////////////////////////
//websSetCfgData(...)
//	Variable Name	==>	File Name
//------------------------------------------------------------------------------
//	pFileName		==>	Open File Name
//	pTag			==>	TAG_xxx
//	nDataCount		==>	Data number for setting.
//	pData			==>	Data content for setting.
//
//	Return Value :	0 is FALSE. 1 is TRUE
//
int websSetCfgData(const char_t* pFileName, const char_t* pTag, int nDataCount,
                   const char_t* pData, ... )
{
	FILE   	*fdIn, *fdOut;
	char_t 	arrInLine[MAX_FILELINE_LEN];
	char_t	strTempName[MAX_FILENAME_LEN];
	char_t	buf[BUF_SIZE_50K];	
	char_t 	arrBeginTag[MAX_TAG_LEN], arrEndTag[MAX_TAG_LEN];
	bool_t 	bTagArea = FALSE;
	va_list	args;
	char* p1String=NULL;

	// First, extract data for list and store into buffer
    	va_start( args, pData );
	gstrcpy(buf, pData);
	
	
    	while( --nDataCount )
    	{    	
 		pData = va_arg(args, char_t *);
		gstrcat(buf, pData);
	}
	
    	va_end(args);

	memset(arrBeginTag, 0x00, MAX_TAG_LEN);
	memset(arrEndTag, 0x00, MAX_TAG_LEN);
    	gsprintf(arrBeginTag, "#<< %s", pTag);
    	gsprintf(arrEndTag, "#>> %s", pTag);    
	
	if ((fdIn = gfopen(pFileName, "r+t")) == NULL)
	{
		fclose(fdIn);
		return 0;
	}

	gsprintf(strTempName, T("%s.tmp"), pFileName);
	if ((fdOut = gfopen(strTempName, "w+")) == NULL)
	{
		fclose(fdOut);
		return 0;
	}

	while (gfgets(arrInLine, sizeof(arrInLine), fdIn))    
    	{
        	if (!gstrlen(arrInLine)) continue; //Null line 
		p1String= strstr (arrInLine, pTag);  
		if (p1String == NULL) 
      		gfprintf(fdOut, "%s", arrInLine); 
		else
      		gfprintf(fdOut, "%s\"%s\"\n", pTag,buf); 
		       
		   
		
#if 0 
		// remove "\n" and keep string only
        	arrInLine[gstrlen(arrInLine)-1] = 0; 
       
        	if (gstrncmp(arrInLine, arrBeginTag, sizeof(arrBeginTag)) == 0) 
        	{
        		//trace(8, "Tag found: %s\n", arrBeginTag);
	        	bTagArea = TRUE;
        	}
        
       		gfprintf(fdOut, "%s\n", arrInLine);        
       	
		if (bTagArea)
		{
			// Print all datas to file
			int ret;
			ret = gfprintf(fdOut, buf);			

			//trace(8, "Retrun value of fprintf:%d\n", ret);			
			while (gfgets(arrInLine, sizeof(arrInLine), fdIn))
			{
				arrInLine[gstrlen(arrInLine)-1] = 0;
		        	if (gstrncmp(arrInLine, arrEndTag, sizeof(arrEndTag)) == 0)
		        	{
					//trace(8, "%s of EndTag found: %s\n", pFileName, arrEndTag);
			       		gfprintf(fdOut, "%s\n", arrInLine);
					bTagArea = FALSE;
					break;
				}
			}			
		}   
#endif		     
    	}

	fclose(fdIn);
	fclose(fdOut);

	if (gremove(pFileName) == 0)
	{
		grename(strTempName, pFileName);	
	}
	else
	{
		//trace(3, T("Cannot remove %s file!!!"), pFileName);
	}
	
	return 1;
}

main( )
{

    	char_t	*name;
	char_t	sValue[MAX_FILELINE_LEN],sConnectedAP_BSSID[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];
	

	FILE* fp; 	
	 
	//char buffer[80];  
	//char sBeginTag[64];  
	char sLine[80];  
	char* sConnMAC=NULL;
	char* sDevice=NULL;      
	char* sBSSID=NULL;  
	char* sSSID=NULL;  
	char* sChannel=NULL; 
	char* sWEP=NULL;   
	char* sRSSI=NULL;   
	char* sAwep;
	char* sBWEP=NULL;
	char* sMAC;      
	char* sDataRate;  
	//char seps[]="\t\n\""; 
	char seps[]="\n\" "; 
	char seps0[]="\n"; 
	char seps1[] = "\n\""; 
	char* p1String=NULL;
	char* sHidden=NULL;   //hidden SSID
	char* sBHidden=NULL;

	int iSelectedMode= 0;
	int iSelectedAP=0; //0:NOT BE SELECTED AP, 1:BE SELECTED AP
	int iDisableCheck=0; //0:not disable checkbox,1:disable
	int i=0;
	int j=0;
	int kg;
	char rBSSID[16];  
	char rSSID[80];  
	char rChannel[80]; 
	char rWEP[80];   
	char rDevice[3];   
	char rRSSI[5];   
	char rHidden[80];   //hidden SSID
	char rBSSID2[16];  
	char rSSID2[80];  
	char rChannel2[80]; 
	char rWEP2[3];   
	char rDevice2[3];   
	char rRSSI2[5];   
	char rHidden2[3];   //hidden SSID
	
	int rss1,rss2;
unsigned char j2[12];
unsigned char j1[12];
unsigned char c1;

       while (j==0) {		
	if (RWReg(4,1)) {
	system("rm /nv/a");
	system("ifconfig eth0 down");
	system("iwpriv eth0 op_mode 3");
	system("iwpriv eth0 wlandev_mac 00:00:00:00:00:00");
	system("ifconfig eth0 nick 8668");
	system("iwpriv eth0 hiddenSsid 0");
	system("ifconfig eth0 essid 1");
	system("iwpriv eth0 op_rate 3");
	system("ifconfig eth0 channel 1");
	system("iwpriv eth0 preamble 2");
	system("ifconfig eth0 rts 2312");
	system("ifconfig eth0 frag 2312");
	system("iwpriv eth0 beacon_interval 100");
	system("iwpriv eth0 authType 0");
	system("ifconfig eth0 up");
	sleep (3);
	system("iwpriv eth0 apc_survey");
	sleep (3);
	system("cat /proc/net/apc_survey > /nv/a");
	
	
	
	
	//int iWriteToWeb=0; //0:need to write line on web;1: not need to 
	       //fp = fopen ("/proc/net/apc_survey", "r");  //real code,ORIGINAL
	       fp = fopen (APC_SURVEY, "r");  //real code
		if (fp==NULL)  
		{     printf ("-----OPEN Site Survey result ERROR: \n");    
		      return -1;  
	       }  

		

		i=0;
		kg=0;
		while (feof(fp)==0) 
		{ 
		   fgets(sLine,80,fp);  //	gsprintf(sAPName, T("WLAN_AP_NAME=\"%s\"\n"), pAPName);
//	gsprintf(sBasicRate, T("WLAN_BASIC_RATE=\"%s\"\n"), pBasicRate);

//		   printf("%s",sLine);  
		   

		   //get Connected AP MAC data
		   p1String= strstr (sLine, "Connected_AP_MAC");  
		   //fgetpos(fp,&pos);    
		   if (p1String != NULL)    
		   {     
		   	if ((sConnMAC=strstr(p1String,"Connected_AP_MAC"))!=NULL)   
			{	
				if (strtok(sConnMAC,"=")!=NULL)   
				{          
				     //sDevice=strtok(NULL,seps);  //original
				     sConnMAC=strtok(NULL,seps1); 
				     sConnMAC=strtok(NULL,seps1); //required to repeat
				     //if (i==0) 
					// i++;

				     
				    // ifx_httpdWrite(wp, T("\t\t\t<tr align=center bgcolor=\"#ffffff\">\n"));				    
				     //ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font><input type=\"hidden\" name=\"device%d\" value=\"%s\"></td>\n"),sDevice,i,sDevice);								     			
				     
                                  			 
//				     printf ("-----cONNECTED AP: %s",sConnMAC);   
				}          
			}    
		    } 
		   
                  //get device type data
		   p1String= strstr (sLine, "Device");  
		   //fgetpos(fp,&pos);    
		   if (p1String != NULL)    
		   {     
		   	if ((sDevice=strstr(p1String,"Device"))!=NULL)   
			{	
				if (strtok(sDevice,"=")!=NULL)   
				{          
				     //sDevice=strtok(NULL,seps);  //original
				     sDevice=strtok(NULL,seps1); 
				     sDevice=strtok(NULL,seps1); //required to repeat
				     if (i==0) 
					 i++;

				     
                                  			 
//				     printf ("-----Device Type: %s i=%i\n",sDevice,i); 
				     strcpy(rDevice,sDevice);  
				}          
			}    
		    } 


		   p1String= strstr (sLine, "Channel");  //fgetpos(fp,&pos);   

		   if (p1String != NULL)   
		   {     
		       if ((sChannel=strstr(p1String,"Channel"))!=NULL)   
		      {	
		          if (strtok(sChannel,"=")!=NULL)        
		          {          
		              //sChannel=strtok(NULL,seps);   //original
		              sChannel=strtok(NULL,seps1); 
			       sChannel=strtok(NULL,seps1); //required to repeat
			       
//			       printf ("-----Channel:%s\n",sChannel);     
				     strcpy(rChannel,sChannel);  
			   }          
		      }    
		    }

		    p1String= strstr (sLine, "Hidden");   
		    if (p1String != NULL)    
		    {     
		        if ((sHidden=strstr(p1String,"Hidden"))!=NULL)  
			{	
//			    printf ("-----Hidden SSID0:%s\n",sHidden);    
			    if (strtok(sHidden,"=")!=NULL)     
			    {         
			        
				 sHidden=strtok(NULL,seps1);
				// printf ("-----Hidden SSID1:%s\n",sHidden); 
				 sHidden=strtok(NULL,seps1);//required to repeat				 
				
//				 ifx_httpdWrite(wp, T("\t\t\t<input type=\"hidden\" name=\"IfHiddenSSID%d\" value=\"%s\"></td>\n"),i,sHidden);	
                           
				
//				 printf ("-----Hidden SSID:%s\n",sHidden);    
				strcpy(rHidden,sHidden);				  
			     }         
		        }   
		     }    //


		   
		   
		    p1String= strstr (sLine, "BSSID");  
			//fgetpos(fp,&pos);   
		    if (p1String != NULL)   
		   {      
		        if ((sBSSID=strstr(p1String,"BSSID"))!=NULL)   
			{	
			    if (strtok(sBSSID,"=")!=NULL)       
			    {           
			         //sBSSID=strtok(NULL,seps);   //original  
			         sBSSID=strtok(NULL,seps1);				
				  sBSSID=strtok(NULL,seps1);   //required to repeat

			        // iWriteToWeb=1; // need to write to web
//			         ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font><input type=\"hidden\" name=\"BSSID%d\" value=\"%s\"></td>\n"),sBSSID,i,sBSSID);	
				 
//				  printf ("-----BSSID:%s\n",sBSSID);   
				     strcpy(rBSSID,sBSSID);  
				 // if (!gstrcmp(sBSSID,sConnectedAP_BSSID))
				 // 	iSelectedAP=1;
				    if (!gstrcmp(sBSSID,sConnectedAP_BSSID))
				    {
				       printf ("-----FIND CONNECT AP MAC--- \n");  
				       iSelectedAP=1;
				    }
			    }         
			}    
		    }   
		    p1String= strstr (sLine, "ESSID");  //fgetpos(fp,&pos);   

		   if (p1String != NULL)   
		   {     
		       if ((sSSID=strstr(p1String,"ESSID"))!=NULL)   
		      {	
		          if (strtok(sSSID,"=")!=NULL)        
		          {          
		              //sSSID=strtok(NULL,seps);   //original
		              //printf ("-----ESSID0:%s\n",sSSID);  
			       sSSID=strtok(NULL,seps0);
				//printf ("-----ESSID0-1:%s\n",sSSID); 
				//printf ("-----str length:%d\n",strlen(sSSID)); 

                            //the following is original
				//if (!gstrcmp(sSSID,sValue))
				 // 	iSelectedAP=1;

				if (strlen(sSSID)>3)  //""-> length=3
				{
					sSSID=strtok(sSSID,seps1); 
			              //printf ("-----ESSID1:%s\n",sSSID);  
				       sSSID=strtok(NULL,seps1);	
					//printf ("-----ESSID2:%s\n",sSSID);  
					

					 iDisableCheck=0;
					 //the following is original
				        //if (!gstrcmp(sSSID,sValue))
				        //iSelectedAP=1;		       
			        
				}
				else
				{
					gstrcpy(sSSID,"");	
					//iDisableCheck=1; //TEMP MARK
			       }
				
			        
				     
			    }
//			       ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font><input type=\"hidden\" name=\"ESSID%d\" value=\"%s\"></td>\n"),sSSID,i,sSSID);	
			       
//			       printf ("-----ESSID:%s\n",sSSID);     
				     strcpy(rSSID,sSSID);  
		       }          
		      }    	   
		    p1String= strstr (sLine, "RSSI");  //fgetpos(fp,&pos);   

		   if (p1String != NULL)   
		   {     
		       if ((sRSSI=strstr(p1String,"RSSI"))!=NULL)   
		      {	
		          if (strtok(sRSSI,"=")!=NULL)        
		          {          
		              //sSSID=strtok(NULL,seps);   //original
		              //printf ("-----ESSID0:%s\n",sSSID);  
			  //     sRSSI=strtok(NULL,seps0);
			       	sRSSI=strtok(NULL,seps1);
				 sRSSI=strtok(NULL,seps1);//required to repeat

				//printf ("-----ESSID0-1:%s\n",sSSID); 
				//printf ("-----str length:%d\n",strlen(sSSID)); 

                            //the following is original
				//if (!gstrcmp(sSSID,sValue))
				 // 	iSelectedAP=1;
				
			        
				     
			    }
//			       ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font><input type=\"hidden\" name=\"ESSID%d\" value=\"%s\"></td>\n"),sSSID,i,sSSID);	
			       
//			       printf ("-----RSSI:%s\n",sRSSI);     
				     strcpy(rRSSI,sRSSI);  
		       }          
		      }    	   

		  

		    p1String= strstr (sLine, "WEP");   
		    if (p1String != NULL)    
		    {     
		        if ((sWEP=strstr(p1String,"WEP"))!=NULL)  
			{	
			    if (strtok(sWEP,"=")!=NULL)     
			    {         
			        //sWEP=strtok(NULL,"\t(");  
				 //sWEP=strtok(NULL,seps);  //original
				 sWEP=strtok(NULL,seps1);
				 sWEP=strtok(NULL,seps1);//required to repeat
//			       printf ("-----WEP:%s\n",sWEP);     
				     strcpy(rWEP,sWEP);  
				 
				//if ((sBWEP=strstr(sWEP,"1"))!=NULL) //original
				 if (!gstrcmp(sWEP,"1"))
				 {
				    sBWEP="ENABLE";
//				    ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font><input type=\"hidden\" name=\"WEP%d\" value=\"1\"></td>\n"),sBWEP,i);		
				 }
				 else
				 {
				    sBWEP="DISABLE";
				 }
                           
//				 i=i+1;	//record number	
				 iSelectedAP=0; //RESET AP Selected
//				 ifx_httpdWrite(wp, T("\t\t\t</tr>\n"));
				 //printf ("-----WEP:%s\n",sWEP);    
				 //printf ("-----BWEP:%s\n",sBWEP); 
			     }         
		        }   
		     }    //get_SiteSurveyDatafromString(p1String,sBSSID,sSSID);  
		        //sscanf (buffer, "SSID  = %s", sSSID);   
#if 1	
		    p1String= strstr (sLine, "Extended");   
		    if (p1String != NULL)  {  
//		  	printf("11g");
//                       printf("rDevice=%s i=%i\n",rDevice,i);		    
	               if ( !strcmp(rDevice ,"11g")) {
#if 1	       
		       if (i==1) {
		       strcpy(rChannel2,rChannel);
		       strcpy(rBSSID2,rBSSID);
		       strcpy(rSSID2,rSSID);
		       strcpy(rRSSI2,rRSSI);
		       strcpy(rHidden2,rHidden);	       
		       strcpy(rWEP2,rWEP);	       
			rss1=atoi(rRSSI);
			kg=1;
//			printf("rss1=%i\n",rss1);	       
		       }
		       else {
		       rss2=atoi(rRSSI);
//			printf("rss2=%i\n",rss2);	       
		       if (rss2 > rss1) {
		       strcpy(rChannel2,rChannel);
		       strcpy(rBSSID2,rBSSID);
		       strcpy(rSSID2,rSSID);
		       strcpy(rRSSI2,rRSSI);
		       strcpy(rHidden2,rHidden);	       
		       strcpy(rWEP2,rWEP);	       
	       
		       }
		       }
#endif	       
			i++;
#if 0			
                       printf("Channel=%s\n",rChannel2);
		       printf("BSSID=%s\n",rBSSID2);
		       printf("ESSID=%s\n",rSSID2);
		       printf("RSSI=%s\n",rRSSI2);
		       printf("Hidden=%s\n",rHidden2);
		       printf("WEP=%s\n",rWEP2);
#endif		       
//		  	printf("11g");
		   	   }
		  }
#endif		     
		        //fgets(sLine,80,fp);  //printf("%s\n",sLine);    
		  }    //while

		  
 
                		  
		    /* Locate the line that starts with "model name".  */  //match = strstr (buffer, "cpu MHz"); 
//		    printf ("----i=%i\n",i);    
		    fclose (fp);
        if (kg == 1) {		    
		    for (i=0; i < 12; i++){
		    if ( rBSSID2[i] > 96 ) rBSSID2[i] = rBSSID2[i]-32;//low case to upper case
		    j2[i]=rBSSID2[i];
		    }
#if 1 //p wpa2 key
c1=0x0; 
//printf("mac=%s %i argc=%i\n",argv[1],strlen(argv[1]),argc);
for (i=0;i < 12 ;i++) {
if (j2[i] > 0x40) {
j2[i]=j2[i] & ~(0x20);
}
#if 0 
if ((j2[i] < 0x30) || (j2[i] > 0x46)) {
//printf("error [%i]=%c\n",i+1,j[i]);
exit();
}
#endif
//printf("%c",j[i]) ;
c1=c1 ^ j2[i];

}
// printf("\nc1=%2x\n",c1);
 for (i=0;i < 12 ;i++) {
 if (i > 0 ) {
 if (j2[i] == j2[i-1] ) j2[i]=j2[i]+i;
 }
 j1[i]=((j2[i] ^ c1) % 10 ) + 0x30 ;
 //printf("%c",j1[i]); 
 }
// printf("\n");


#endif		    
		    
// 	gsprintf(rChannel, T("WLAN_CHANNEL=\"%s\"\n"), rChannel2);
//	gsprintf(rSSID, T("WLAN_ESSID=\"%s\"\n"), rSSID2);
//	gsprintf(rHidden, T("WLAN_HIDDEN_SSID=\"%s\"\n"), rHidden2);
		websSetCfgData(FILE_RC_CONF,"WLAN_CHANNEL=", 1,rChannel2);
		websSetCfgData(FILE_RC_CONF,"WLAN_HIDDEN_SSID=", 1,rHidden2);
//	websSetCfgData(FILE_RC_CONF,"WLAN_KEY1=", 1,rBSSID2);
//		websSetCfgData(FILE_RC_CONF,"WLAN_PASSPHRASE=", 1,rBSSID2);
		websSetCfgData(FILE_RC_CONF,"WLAN_PASSPHRASE=", 1,j1);
	
		if (!strcmp(rWEP2,"1")) {
		websSetCfgData(FILE_RC_CONF,"WLAN_KEY_USED=", 1,"1");
		websSetCfgData(FILE_RC_CONF,"WLAN_ENCRY_TYPE=", 1,"5");
		websSetCfgData(FILE_RC_CONF,"WLAN_AUTH_TYPE=", 1,"7");
		}
		else {
		websSetCfgData(FILE_RC_CONF,"WLAN_KEY_USED=", 1,"0");
		websSetCfgData(FILE_RC_CONF,"WLAN_ENCRY_TYPE=", 1,"0");
		websSetCfgData(FILE_RC_CONF,"WLAN_AUTH_TYPE=", 1,"0");
	
		}

	
#if 1	
                       printf("Channel=%s\n",rChannel2);
		       printf("BSSID=%s\n",rBSSID2);
		       printf("ESSID=%s\n",rSSID2);
		       printf("RSSI=%s\n",rRSSI2);
		       printf("Hidden=%s\n",rHidden2);
		       printf("WEP=%s\n",rWEP2);
		       
#endif		       
		    for (i=0; i < 12; i++){
		     j1[i] = j1[i+2];//low case to upper case
		    }
		websSetCfgData(FILE_RC_CONF,"WLAN_KEY1=", 1,j1);
		    for (i=0; i < 10; i++){
		     rBSSID2[i] = rBSSID2[i+4];//low case to upper case
		    }
 	       if (!strcmp(rSSID2 , "")){
 	       strcpy(rSSID2,DEFAULT_SSID);
// 	       strcat(rSSID2,rBSSID2);
		websSetCfgData(FILE_RC_CONF,"WLAN_HIDDEN_SSID=", 1,"1");
	
 	       }
		websSetCfgData(FILE_RC_CONF,"WLAN_ESSID=", 1,rSSID2);
         system("rawaccess -s");	   
        }    
	       system("reboot");

	}
	}
   }
   
//}
