/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/


#include "ifx_emf.h"
#include <signal.h>
#include <unistd.h> 
#include <sys/types.h>
#include <sys/wait.h>
#include <ifx_common.h>
#include "ifx_httpd_method.h"
#include "ifx_common_defs.h"
#include "ifx_iip_fifos.h"
#include "ifx_cm.h"
#include "ifx_src_cgi.h"
#include "ifx_web_common.h"

#ifdef DMALLOC
#include "dmalloc.h"
#endif
/*
void ifx_set_logout(httpd_t wp, char_t *path, char_t *query)
{
	//reset parameter
	connection.allowed = 0;
	connection.block = 0;
    memset(connection.ipaddr,0x00,sizeof(connection.ipaddr));
#ifdef ATA
	ifx_debug_printf("##########################   IFX_CM_WebShut  ---> #######################");
	IFX_CM_WebShut();
	ifx_debug_printf("##########################   IFX_CM_WebShut  <--- #######################");
#endif
	 ifx_httpdNextPage(wp);
}
*/
void inline ifx_get_currentUser_authority(int eid, httpd_t wp, int argc, char_t **argv)
{
#ifdef IIP
	if (g_nCurrentUserLevel == 0)
		ifx_httpdWrite(wp, T("0"));
	else
		ifx_httpdWrite(wp, T("1"));
#endif
#ifndef IIP
	if (g_nCurrentUserLevel == 0)
		ifx_httpdWrite(wp, T("0"));
	else
	if (g_nCurrentUserLevel == 1)
    	ifx_httpdWrite(wp, T("1"));
    else
        ifx_httpdWrite(wp, T("2"));
#endif //#ifndef IIP
	return;
}

int inline ifx_get_currentUser_authority_CGI(int eid, httpd_t wp, int argc, char_t **argv)
{
#ifdef IIP
	if (g_nCurrentUserLevel == 0)
		return 0;
	else
		return 1;
#endif
#ifndef IIP
	if (g_nCurrentUserLevel == 0)
		return 0;
	else
	if (g_nCurrentUserLevel == 1)
    	return 1;
    else
        return 2;
#endif //#ifndef IIP


   return 0;
}

/*****************************************************************************
 *  Function Name   : ifx_get_defineSRTP
 *  Description     : This function is invoked to separate SRTP in each
                 ASP pages
 *  Input Values    :
 *  Output Values   : 1 for SRTP_ON, 0 for SRTP_OFF
 *
 *  Return Value    : 0  - Success
 *                    -1 - Failure
 *  Notes           :
 ****************************************************************************/
int inline ifx_get_defineSRTP(int eid, httpd_t wp, int argc, char_t **argv)
{
#ifdef SRTP
	return 1;
#else
	return 0;
#endif
}

