/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include	"ifx_iip_fifos.h"
#include	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>


int ifx_get_lan_dhcp_clients(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	sValue[MAX_FILELINE_LEN], sCommand[MAX_FILELINE_LEN];
	int		i, nLine = 0;
	char *ptr_temp = NULL;//121704-

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(sCommand, 0x00, MAX_FILELINE_LEN);

	gsprintf(sCommand, T("dumpleases | grep -c seconds"));
	if (ifx_GetCfgData((char_t*)sCommand, NULL, "1", sValue) == 1)
	{
		nLine = gatoi(sValue);
	}

	for(i = 2; i <= nLine+1; i++)
	{
		ifx_httpdWrite(wp, T("<tr align=\"center\" bgcolor=\"#ffffff\">\n"));

		memset(sValue, 0x00, MAX_FILELINE_LEN);
		memset(sCommand, 0x00, MAX_FILELINE_LEN);

		gsprintf(sCommand, T("dumpleases | awk '{ print $2 }'"));
		if (ifx_GetCfgData((char_t*)sCommand, NULL, ptr_temp = stritoa(i, NULL, 0), sValue) == 1)
		{
			ifx_httpdWrite(wp, T("  <td width=\"20%%\" align=\"center\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">%s</font></td>\n"), sValue);
			if (ptr_temp)
				free(ptr_temp);
		}

		memset(sValue, 0x0, MAX_FILELINE_LEN);
		memset(sCommand, 0x00, MAX_FILELINE_LEN);

		gsprintf(sCommand, T("dumpleases | awk '{ print $1 }'"));
		if (ifx_GetCfgData((char_t*)sCommand, NULL, ptr_temp = stritoa(i, NULL, 0), sValue) == 1)
		{
			ifx_httpdWrite(wp, T("  <td width=\"30%%\" align=\"center\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">%s</font></td>\n"), sValue);
			if (ptr_temp)
				free(ptr_temp);
		}

		ifx_httpdWrite(wp, T("</tr>\n"));
	}
	return 0;
}
