#!/bin/sh
TOPDIR=`pwd`/../../../../
. ${TOPDIR}/tools/build_tools/Path.sh
APPS_NAME="ifx_common"

echo "----------------------------------------------------------------------"
echo "-----------------------    build ifx_common   ------------------------"
echo "----------------------------------------------------------------------"

#IFX_CC=gcc
#IFX_LD=ld
#IFX_CFLAGS=-O0

#make clean

make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}"
ifx_error_check $? 

${IFX_STRIP} --strip-unneeded ${IFX_COMMON_DIR}/lib/libifx*
ifx_error_check $? 

cp -f ${IFX_COMMON_DIR}/lib/libifx* ${BUILD_ROOTFS_DIR}/lib
ifx_error_check $? 

