/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>



void ifx_set_wan(httpd_t wp, char_t *path, char_t *query)
{
	 // Solved WAN Mode change issue form "wan_main.asp -> wan_pptp.asp/wan_pppoe.asp
	 // WAN Mode will be updated under its coresponding functions, hence we only need to
	 // link to the next page
#if 0 

	char_t	*pWanType = ifx_httpdGetVar(wp, T("WT"), T(""));
	char_t	sSelWanType[MAX_DATA_LEN];
	int 	nValue = gatoi(pWanType);
	int		nWanMode = websGetWanMode();
	char_t	sWanFlag[MAX_DATA_LEN];

	memset(sWanFlag, 0x00, MAX_DATA_LEN);
	if (nValue != nWanMode)
	{
		gsprintf(sWanFlag, "wan_change=\"YES\"\n");
	}
	else
	{
		gsprintf(sWanFlag, "wan_change=\"NO\"\n");
	}

	switch (nValue)
	{
		case 1:
		gsprintf(sSelWanType, "ipoption_adm1=\"DHCPC\"\n");
		break;
		
		case 2:
		gsprintf(sSelWanType, "ipoption_adm1=\"FIXED\"\n");
		break;

		case 3:
		gsprintf(sSelWanType, "ipoption_adm1=\"PPPOE\"\n");
		break;
		
		case 4:
		gsprintf(sSelWanType, "ipoption_adm1=\"PPTP\"\n");
		break;
		
		default:
		gsprintf(sSelWanType, "ipoption_adm1=\"DHCPC\"\n");
		return;
	}
			
	websSetCfgData(FILE_RC_CONF, TAG_WAN_MAIN, 1,  sSelWanType);
	websSetCfgData(FILE_RC_CONF, TAG_WAN_FLAG, 1,  sWanFlag);

	//add by calvinc 20040519 save to flash
	system(SERVICE_RESTORE);        
        //end addd                  
#endif	                                
	ifx_httpdNextPage(wp);	
}

